app/routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

/**
 * Callback payments
 */
Route::group(['prefix' => 'api'], function () {
    Route::group(['prefix' => 'payments'], function () {
        Route::post('coinpayments/confirmation', "\App\Services\Payments\Coinpayments@confirmation");
    });
});

Route::group(['middleware' => ['auth']], function () {
    /**
     * Backend
     */
    Route::group(['prefix' => 'api'], function () {
        Route::prefix('admin')->middleware(['role:Admin'])->group(function () {
            Route::apiResource('users', Admin\UserController::class)->names([
                'store' => 'api.admin.users.store',
                'update' => 'api.admin.users.update',
                'destroy' => 'api.admin.users.destroy',
            ])->only(['store', 'update', 'destroy']);

            Route::put('orderPackage/approved/{ordersPackage}', "Admin\OrdersPackageController@approved")->name('api.orderPackage.approved');
            Route::put('orderPackage/cancelled/{ordersPackage}', "Admin\OrdersPackageController@cancelled")->name('api.orderPackage.cancelled');
            Route::put('transactions/approved/{transaction}', "Admin\TransactionController@approved")->name('api.transactions.approved');
            Route::put('transactions/cancelled/{transaction}', "Admin\TransactionController@cancelled")->name('api.transactions.cancelled');

            Route::apiResource('settings', Admin\SettingController::class)->names([
                'store' => 'api.admin.settings.store',
                'update' => 'api.admin.settings.update',
                'destroy' => 'api.admin.settings.destroy',
            ])->only(['store', 'update', 'destroy']);
        });

        Route::apiResource('users', UserController::class)->names([
            'update' => 'api.users.update',
        ])->only([
            // 'index',
            'update',
        ]);

        Route::put('userAuthentication/{user}', "UserAuthenticationController@update")->name('api.usersauthetication.update');
        Route::put('userWallet/{user}', "UserWalletController@update")->name('api.userswallet.update');
        Route::post('userWallet/{user}', "UserWalletController@store")->name('api.userswallet.store');
        Route::put('userBroker/{user}', "UserBrokerController@update")->name('api.usersBroker.update');
        Route::post('orderPackage/{user}/{package}', "OrdersPackageController@store")->name('api.orderPackage.store');
        Route::post('tickets/{user}', "StatesTicketController@store")->name('api.tickets.store');
        Route::put('tickets/{user}/{supportTicket}', "StatesTicketController@update")->name('api.tickets.update');
    });




    /**
     * Frontend
     */
    Route::prefix('admin')->middleware(['role:Admin'])->group(function () {
        Route::resource('users', Admin\UserController::class)->names([
            'index' => 'admin.users.index',
            'edit' => 'admin.users.edit',
        ])->only(['index', 'create', 'show', 'edit']);
        Route::get('orders', 'Admin\OrdersPackageController@index')->name('admin.ordersPackages.index');
        Route::get('transactions', 'Admin\TransactionController@index')->name('admin.transactions.index');
        Route::get('settings', 'Admin\SettingController@index')->name('admin.settings.index');
        Route::get('settings/create', 'Admin\SettingController@create')->name('admin.settings.create');
        Route::get('settings/{setting}', 'Admin\SettingController@edit')->name('admin.settings.edit');
        Route::prefix('history')->group(function () {
            Route::get('supports', 'Admin\HistoryController@supports')->name('admin.histories.supports');
            Route::get('commissions', 'Admin\HistoryController@commissions')->name('admin.histories.commissions');
            Route::get('users', 'Admin\HistoryController@users')->name('admin.histories.users_lost');
        });
    });

    Route::get('/', 'HomeController@index')->name('home');
    Route::get('/home', 'HomeController@index')->name('home');

    Route::group(['middleware' => [env('IS_EMAIL_VERIFIED') ? 'verified' : 'auth']], function () {
        Route::resource('users', UserController::class)->only(['edit']);
        Route::get('users/tree', 'UserController@tree')->name('users.tree');
        Route::resource('users.referrals', UserReferralController::class)->only(['index']);
        Route::resource('users.wallets', UserWalletController::class)->only(['index']);
        Route::resource('packages', PackagesController::class)->only(['index']);
        Route::get('orders', 'OrdersPackageController@index')->name('ordersPackages.index');
        Route::resource('commissions', CommissionController::class)->only(['index']);
        Route::resource('supportTickets', StatesTicketController::class)->only(['index', 'create', 'show']);
    });
});

Route::get('register/{parent?}', 'Auth\RegisterController@showRegistrationForm')->name('register');
Auth::routes(['verify' => true]);

// // Authentication Routes...
// Route::get('login', 'Auth\LoginController@showLoginForm')->name('login');
// Route::post('login', 'Auth\LoginController@login');
// Route::post('logout', 'Auth\LoginController@logout')->name('logout');

// // Registration Routes...
// Route::get('register/{parent?}', 'Auth\RegisterController@showRegistrationForm')->name('register');
// Route::post('register', 'Auth\RegisterController@register');

// // Password Reset Routes...
// Route::get('password/reset', 'Auth\ForgotPasswordController@showLinkRequestForm')->name('password.request');
// Route::post('password/email', 'Auth\ForgotPasswordController@sendResetLinkEmail')->name('password.email');
// Route::get('password/reset/{token}', 'Auth\ResetPasswordController@showResetForm')->name('password.reset');
// Route::post('password/reset', 'Auth\ResetPasswordController@reset');

app/resources/views/tickets/create.blade.php
@extends('layouts.app')

@section('content')


<div class="box">
    <div class="box-header with-border">
        <h3 class="box-title">Información Financiera</h3>
    </div>
    <div class="box-body">
        <div class="row">
            <div class="col">
                <form-component method="POST" action="{{ route('api.tickets.store', Auth::user()->username) }}"
                    v-slot="slotProps">

                    <div class="form-group">
                        <h5>Asunto <span class="text-danger">*</span></h5>
                        <div class="controls">
                            <input type="text" name="subject" id="subject" class="form-control" value="" required>
                        </div>
                    </div>

                    <div class="form-group">
                        <h5>Comentario <span class="text-danger">*</span></h5>
                        <div class="controls">
                            <input type="text" name="comment" id="comment" class="form-control" value="" required>
                        </div>
                    </div>

                    <div class="d-flex justify-content-end">
                        <p>
                            <a class="btn btn-info" href="{{ route('supportTickets.index') }}">Cancelar</a>
                            <input class="btn btn-success" type="button" name="enviar" value="Guardar cambios"
                                @click="slotProps.onSubmit" />
                        </p>
                    </div>
                </form-component>
            </div>
        </div>
    </div>
</div>

@endsection

@section('js')
@endsection

app/resources/views/tickets/index.blade.php
@extends('layouts.app')

@section('content-header')
<section class="content-header">
    <h1>
        Tickets
    </h1>
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="#"><i class="fa fa-dashboard"></i> Home</a></li>
        <li class="breadcrumb-item active">Tickets</li>
    </ol>
</section>
@endsection

@section('content')

@if(isset($total))
<div class="row">
    <!-- Column -->
    <div class="col-md-6 col-lg-3 col-xlg-3">
        <div class="box box-inverse box-info pull-up bg-hexagons-dark">
            <div class="box-body text-center">
                <div class="flexbox align-content-end">
                    <h2 class="text-white mb-10">Total Tickets</h2>
                    <h1 class="font-light text-white">{{ $total }}</h1>
                </div>
            </div>
        </div>
    </div>
    <!-- Column -->
    <div class="col-md-6 col-lg-3 col-xlg-3">
        <div class="box box-success box-inverse pull-up bg-hexagons-dark">
            <div class="box-body text-center">
                <div class="flexbox align-content-end">
                    <h2 class="text-white mb-10">Completado</h2>
                    <h1 class="font-light text-white">{{ $responded }}</h1>
                </div>
            </div>
        </div>
    </div>
    <!-- Column -->
    <div class="col-md-6 col-lg-3 col-xlg-3">
        <div class="box box-inverse box-dark pull-up bg-hexagons-dark">
            <div class="box-body text-center">
                <div class="flexbox align-content-end">
                    <h2 class="text-white mb-10">Pendiente</h2>
                    <h1 class="font-light text-white">{{ $resolve }}</h1>
                </div>
            </div>
        </div>
    </div>
    <!-- Column -->
    <div class="col-md-6 col-lg-3 col-xlg-3">
        <div class="box box-inverse box-warning pull-up bg-hexagons-white">
            <div class="box-body text-center">
                <div class="flexbox align-content-end">
                    <h2 class="text-white mb-10">Nuevo</h2>
                    <h1 class="font-light text-white">{{ $pending }}</h1>
                </div>
            </div>
        </div>
    </div>
    <!-- Column -->
</div>
@endif

<div class="d-flex justify-content-end align-items-center p-2">
    <a href="{{ route('supportTickets.create') }}" class="btn btn-info text-white">
        Crear Soporte
    </a>
</div>

<div class="row">
    <div class="col-12">
        <div class="box">
            <div class="box-body">
                <div class="table-responsive">
                    <table id="tickets" class="table mt-0 no-wrap {{ isset($datatable) ? 'data-table' : '' }} {{ isset($export) ? 'export-table' : '' }}" data-page-size="10">
                        <thead>
                            <tr class="bg-light">
                                <th>ID #</th>
                                <th>Opened By</th>
                                <th>Cust. Email</th>
                                <th>Sbuject</th>
                                <th>Status</th>
                                <th>Date</th>
                                <th>Action</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach($tickets as $ticket)
                            <tr>
                                <td>{{ $ticket->id }}</td>
                                <td>{{ $ticket->user->username }}</td>
                                <td>{{ $ticket->user->email }}</td>
                                <td>{{ $ticket->subject }}</td>
                                <td><span
                                        class="label label-{{ $ticket->states_ticket_id == 1 ? 'warning': ($ticket->states_ticket_id == 2 ? 'inverse':'success')}}">{{ $ticket->state->name }}</span>
                                </td>
                                <td>{{ $ticket->created_at->diffForHumans() }}</td>
                                <td>
                                    @role('Admin')
                                    {{-- <button type="button" class="btn btn-sm btn-danger-outline" data-toggle="tooltip"
                                        data-original-title="Delete">
                                        <i class="ti-trash" aria-hidden="true"></i>
                                    </button> --}}
                                    @endrole
                                    <a href="{{ route('supportTickets.show', $ticket->id) }}"
                                        class="btn btn-sm btn-success-outline">
                                        <i class="ti-eye" aria-hidden="true"></i>
                                    </a>
                                </td>
                            </tr>
                            @endforeach
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>

@endsection

@section('js')
<script>

</script>
@endsection

app/resources/views/tickets/show.blade.php
@extends('layouts.app')

@section('content-header')
<section class="content-header">
    <h1>
        Ticket
    </h1>
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="#"><i class="fa fa-dashboard"></i> Home</a></li>
        <li class="breadcrumb-item active">Ticket</li>
    </ol>
</section>
@endsection

@section('content')

<div class="row">
    <div class="col-lg-12 col-md-12">
        <div class="box direct-chat">
            <div class="box-header with-border">
                <h3 class="box-title">Ticket History</h3>
            </div>
            <!-- /.box-header -->
            <div class="box-body">
                <!-- Conversations are loaded here -->
                <div id="chat-app" class="direct-chat-messages chat-app">
                    @foreach($supportTicket->comments as $comment)

                    @if(Auth::user()->id == $comment->user->id)
                    <div class="direct-chat-msg right mb-30">
                        <div class="clearfix mb-15">
                            <span class="direct-chat-name pull-right">{{ $comment->user->name }}</span>
                            <span class="direct-chat-timestamp ">{{ $comment->created_at->diffForHumans() }}</span>
                        </div>
                        <!-- /.direct-chat-info -->
                        <img class="direct-chat-img avatar" src="/template/images/user3-128x128.jpg"
                            alt="message user image">
                        <!-- /.direct-chat-img -->
                        <div class="direct-chat-text">
                            {{ $comment->comment }}
                        </div>
                        <!-- /.direct-chat-text -->
                    </div>

                    @else
                    <div class="direct-chat-msg mb-30">
                        <div class="clearfix mb-15">
                            <span class="direct-chat-name">{{ $comment->user->name }}</span>
                            <span class="direct-chat-timestamp pull-right">
                                {{ $comment->created_at->diffForHumans() }}
                            </span>
                        </div>
                        <!-- /.direct-chat-info -->
                        <img class="direct-chat-img avatar" src="/template/images/user1-128x128.jpg"
                            alt="message user image">
                        <!-- /.direct-chat-img -->
                        <div class="direct-chat-text">
                            {{ $comment->comment }}
                        </div>

                        <!-- /.direct-chat-text -->
                    </div>
                    @endif
                    @endforeach
                </div>
                <!--/.direct-chat-messages-->
            </div>
            <!-- /.box-body -->
            <div class="box-footer">
                <form-component method="PUT"
                    action="{{ route('api.tickets.update', [Auth::user()->username,$supportTicket->id]) }}"
                    v-slot="slotProps">
                    <div class="input-group">
                        <input type="text" name="comment" id="comment" placeholder="Type Message ..."
                            class="form-control" required>
                        <span class="input-group-btn">
                            <button type="button" class="btn btn-warning" @click="slotProps.onSubmit">Send</button>
                        </span>
                    </div>
                </form-component>
            </div>
            <!-- /.box-footer-->
        </div>
        <!-- /. box -->
    </div>
    <!-- /.col -->
</div>

@endsection

@section('js')
<script>

</script>
@endsection